; ENEMIES.ASM
; Routines to update, move, reset, the enemies.

;==============================================================
; IX = IX + 4
;==============================================================

inc_ix_4:
	inc ix
	inc ix
	inc ix
	inc ix
	ret


rand_enemies:
	.db $10,$0C,$1C,$20,$08,$44,$04,$14,$24,$18
rand_enemies_end:




;==============================================================
; ADD AN ENEMY
;==============================================================

add_random_enemy:

	ld b,rand_enemies_end-rand_enemies-1
	call random
	ld l,a
	ld h,0
	ld de,rand_enemies
	add hl,de
	ld a,(hl)
add_enemy:
	push af
	ld hl,enemies_table
	ld de,8
	ld b,8
-:	ld a,(hl)
	or a
	jr z,+
	add hl,de
	djnz -
	pop af
	ld a,1
	cp 0
	ret	; Failed!


+:	pop af	; Succeeded
	; So, A = enemy sprite number
	ld (hl),a
	inc hl

	; Now, we need to select the starting X,Y for this particular enemy

	ld de,path_spirals
	cp $04
	jr z,enemy_uses_path

	ld de,path_loop
	cp $14
	jr z,enemy_uses_path

	ld de,path_crossover
	cp $24
	jr z,enemy_uses_path


	cp $18
	jr z,random_x

	cp $0C
	jr z,random_x

	cp $1C
	jr z,random_x

	cp $20
	jr z,random_x

	cp $10
	jr z,shield_place

	cp $44
	jr z,use_player_x
	cp $08
	jr z,use_centre_x

	; Enemy not recognised
	ret


shield_place:
	ld a,208+8
	ld (hl),a
	inc hl
	ld a,32
	ld (hl),a
	inc hl
	xor a
	ld (hl),a
	ret


enemy_uses_path:
	; So, the enemy type A uses a path, does it?
	; DE is a POINTER to the start of the path table:
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	xor a
	ld (hl),a
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	xor a
	ret

use_centre_x:
	ld b,0
	ld de,sinus_lut
	jr +
use_player_x:
	ld a,(player_x)
	ld b,a
	ld de,fast_sinus_lut
	jr +
random_x:
	; Fast attacking ships
	ld b,0
	push hl
	ld b,160-32
	call random
	pop hl
	add a,128-80+16
	ld b,0
+:	ld (hl),a	;+1
	inc hl
	xor a
	ld (hl),a	;+2
	inc hl
	ld (hl),e	;+3
	inc hl
	ld (hl),d	;+4
	inc hl
	ld (hl),b	;+5
	inc hl
	xor a
	ld (hl),a	;+6
	ret


;==============================================================
; PATHS
;==============================================================

; Looping path:
path_loop:
.db 86, -11
.db 48
.db 48
.db 48
.db 48
.db 32
.db 49
.db 48
.db 32
.db 48
.db 48
.db 33
.db 48
.db 32
.db 33
.db 48
.db 32
.db 33
.db 32
.db 33
.db 32
.db 33
.db 32
.db 33
.db 32
.db 33
.db 33
.db 32
.db 17
.db 32
.db 33
.db 17
.db 33
.db 16
.db 33
.db 17
.db 33
.db 16
.db 17
.db 33
.db 17
.db 17
.db 17
.db 33
.db 17
.db 16
.db 17
.db 17
.db 17
.db 17
.db 17
.db 17
.db 1
.db 17
.db 17
.db 17
.db 17
.db 1
.db 17
.db 17
.db 1
.db 17
.db 1
.db 17
.db 1
.db 17
.db 1
.db 17
.db 1
.db 17
.db 1
.db 1
.db 17
.db 1
.db 1
.db 1
.db 17
.db 1
.db 1
.db 1
.db 1
.db 1
.db 1
.db 1
.db 17
.db 1
.db 1
.db 1
.db 0
.db 1
.db 1
.db 145
.db 1
.db 1
.db 0
.db 1
.db 1
.db 1
.db 0
.db 145
.db 1
.db 0
.db 1
.db 0
.db 145
.db 1
.db 0
.db 1
.db 144
.db 1
.db 0
.db 0
.db 145
.db 0
.db 1
.db 144
.db 0
.db 0
.db 145
.db 0
.db 0
.db 144
.db 1
.db 0
.db 144
.db 0
.db 0
.db 144
.db 0
.db 0
.db 144
.db 0
.db 0
.db 144
.db 0
.db 9
.db 144
.db 0
.db 0
.db 153
.db 0
.db 0
.db 144
.db 9
.db 0
.db 153
.db 0
.db 0
.db 9
.db 144
.db 9
.db 0
.db 9
.db 153
.db 0
.db 9
.db 0
.db 9
.db 153
.db 0
.db 9
.db 9
.db 9
.db 0
.db 9
.db 9
.db 153
.db 9
.db 9
.db 0
.db 9
.db 9
.db 9
.db 25
.db 9
.db 9
.db 9
.db 9
.db 9
.db 9
.db 9
.db 25
.db 9
.db 9
.db 9
.db 25
.db 9
.db 9
.db 25
.db 9
.db 25
.db 9
.db 25
.db 9
.db 25
.db 9
.db 25
.db 9
.db 25
.db 25
.db 9
.db 25
.db 25
.db 25
.db 25
.db 9
.db 25
.db 25
.db 25
.db 25
.db 25
.db 25
.db 16
.db 25
.db 41
.db 25
.db 25
.db 25
.db 41
.db 25
.db 16
.db 41
.db 25
.db 41
.db 16
.db 41
.db 25
.db 41
.db 32
.db 25
.db 32
.db 41
.db 41
.db 32
.db 41
.db 32
.db 41
.db 32
.db 41
.db 32
.db 41
.db 32
.db 48
.db 41
.db 32
.db 48
.db 41
.db 48
.db 48
.db 32
.db 48
.db 57
.db 32
.db 48
.db 48
.db 48



path_spirals:
.db 183, 1
.db 25
.db 26
.db 25
.db 26
.db 25
.db 42
.db 26
.db 26
.db 26
.db 25
.db 42
.db 26
.db 26
.db 26
.db 42
.db 26
.db 27
.db 42
.db 26
.db 26
.db 42
.db 27
.db 26
.db 42
.db 26
.db 26
.db 43
.db 26
.db 26
.db 43
.db 26
.db 42
.db 26
.db 26
.db 43
.db 26
.db 42
.db 26
.db 26
.db 43
.db 26
.db 42
.db 26
.db 26
.db 42
.db 26
.db 41
.db 26
.db 26
.db 42
.db 26
.db 25
.db 42
.db 25
.db 26
.db 41
.db 26
.db 25
.db 42
.db 25
.db 25
.db 41
.db 25
.db 25
.db 25
.db 41
.db 25
.db 16
.db 25
.db 25
.db 32
.db 25
.db 16
.db 16
.db 25
.db 16
.db 16
.db 16
.db 16
.db 32
.db 16
.db 17
.db 16
.db 16
.db 17
.db 0
.db 17
.db 17
.db 16
.db 17
.db 17
.db 17
.db 17
.db 1
.db 17
.db 17
.db 17
.db 2
.db 17
.db 18
.db 1
.db 18
.db 17
.db 2
.db 17
.db 2
.db 18
.db 2
.db 18
.db 1
.db 18
.db 2
.db 2
.db 18
.db 2
.db 2
.db 19
.db 2
.db 2
.db 2
.db 2
.db 19
.db 2
.db 2
.db 2
.db 2
.db 3
.db 2
.db 2
.db 3
.db 2
.db 2
.db 2
.db 2
.db 147
.db 2
.db 2
.db 2
.db 2
.db 147
.db 2
.db 2
.db 146
.db 2
.db 2
.db 146
.db 1
.db 146
.db 2
.db 146
.db 2
.db 145
.db 2
.db 145
.db 146
.db 1
.db 146
.db 145
.db 2
.db 145
.db 145
.db 145
.db 1
.db 145
.db 145
.db 145
.db 145
.db 144
.db 145
.db 145
.db 0
.db 145
.db 144
.db 144
.db 145
.db 144
.db 160
.db 144
.db 144
.db 144
.db 144
.db 153
.db 144
.db 144
.db 153
.db 160
.db 153
.db 153
.db 144
.db 153
.db 169
.db 153
.db 153
.db 153
.db 169
.db 153
.db 153
.db 170
.db 153
.db 154
.db 169
.db 154
.db 153
.db 170
.db 153
.db 154
.db 170
.db 154
.db 154
.db 169
.db 154
.db 170
.db 154
.db 154
.db 170
.db 154
.db 171
.db 154
.db 154
.db 170
.db 154
.db 171
.db 154
.db 154
.db 170
.db 154
.db 171
.db 154
.db 154
.db 171
.db 154
.db 154
.db 170
.db 154
.db 155
.db 170
.db 154
.db 154
.db 170
.db 155
.db 154
.db 170
.db 154
.db 154
.db 154
.db 170
.db 153
.db 154
.db 154
.db 154
.db 170
.db 153
.db 154
.db 153
.db 154

path_crossover:
.db 38, 34
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 2
.db 3
.db 3
.db 3
.db 3
.db 18
.db 3
.db 3
.db 19
.db 2
.db 3
.db 18
.db 2
.db 18
.db 18
.db 2
.db 18
.db 17
.db 18
.db 17
.db 1
.db 17
.db 17
.db 16
.db 17
.db 16
.db 32
.db 16
.db 16
.db 25
.db 25
.db 32
.db 25
.db 26
.db 41
.db 26
.db 25
.db 42
.db 26
.db 42
.db 26
.db 42
.db 27
.db 42
.db 27
.db 43
.db 26
.db 43
.db 43
.db 27
.db 43
.db 27
.db 43
.db 27
.db 43
.db 42
.db 27
.db 43
.db 27
.db 42
.db 27
.db 42
.db 27
.db 42
.db 26
.db 42
.db 26
.db 42
.db 26
.db 41
.db 26
.db 25
.db 41
.db 16
.db 25
.db 25
.db 16
.db 32
.db 16
.db 16
.db 17
.db 16
.db 17
.db 17
.db 17
.db 1
.db 18
.db 17
.db 18
.db 2
.db 18
.db 18
.db 2
.db 19
.db 2
.db 19
.db 2
.db 3
.db 3
.db 19
.db 3
.db 3
.db 2
.db 3
.db 3
.db 3
.db 3
.db 3
.db 147
.db 3
.db 2
.db 147
.db 2
.db 3
.db 146
.db 146
.db 3
.db 145
.db 2
.db 146
.db 146
.db 145
.db 145
.db 145
.db 1
.db 145
.db 144
.db 161
.db 144
.db 144
.db 144
.db 153
.db 144
.db 169
.db 153
.db 153
.db 153
.db 169
.db 154
.db 169
.db 154
.db 154
.db 170
.db 154
.db 171
.db 154
.db 171
.db 170
.db 155
.db 171
.db 155
.db 170
.db 155
.db 171
.db 171
.db 155
.db 171
.db 155
.db 171
.db 155
.db 170
.db 171
.db 155
.db 170
.db 155
.db 170
.db 154
.db 171
.db 154
.db 170
.db 153
.db 154
.db 169
.db 154
.db 153
.db 169
.db 153
.db 144
.db 153
.db 160
.db 0
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160
.db 160


; Sinus:
sinus_lut:
.DBSIN 0,160,360/144,50,128

fast_sinus_lut:
.DBSIN 0,160,360/144*2,20,0