; PALFADE.ASM
; Palette fading routines

;==============================================================
; START FADE USING PALETTES AT DE=>HL IN C COLOURS AT SPEED A
;==============================================================

fade_start:
	ld (pal_fade_speed),a
	xor a
	ld (pal_fade_amount),a
	sla c
	ld a,c
	ld (pal_fade_count),a
	push de
	ld b,0
	push bc
	ld de,pal_to
	ldir
	pop bc
	pop de

	ld hl,pal_from
	ex de,hl
	ldir
	ret

;==============================================================
; UPDATE FADE VALUES
;==============================================================

fade_update:
	ld hl,pal_to
	ld de,pal_current
	ld ix,pal_from
	ld a,(pal_fade_count)
	srl a
	ld b,a

-:	push bc

	push de
	push hl
	ld a,(hl)
	and %00001111
	ld e,a
	ld a,(pal_fade_amount)
	call fade_scale
	pop hl
	pop de
	ld (de),a


	push de
	ld a,(ix+0)
	and %00001111
	ld e,a
	ld a,(pal_fade_amount)
	ld d,a
	ld a,$FF
	sub d
	push hl
	call fade_scale
	pop hl
	pop de
	ld b,a
	ld a,(de)
	add a,b
	ld (de),a


	push de
	push hl
	ld a,(hl)
	srl a
	srl a
	srl a
	srl a
	ld e,a
	ld a,(pal_fade_amount)
	call fade_scale
	add a,a
	add a,a
	add a,a
	add a,a
	pop hl
	pop de
	ex de,hl
	or (hl)
	ld (hl),a
	ex de,hl



	push de
	ld e,(ix+0)
	srl e
	srl e
	srl e
	srl e
	ld a,(pal_fade_amount)
	ld d,a
	ld a,$FF
	sub d
	push hl
	call fade_scale
	pop hl
	pop de
	add a,a
	add a,a
	add a,a
	add a,a
	ld b,a
	ld a,(de)
	add a,b
	ld (de),a



	

	inc hl
	inc de
	inc ix

	;---


	push de
	ld a,(hl)
	inc hl
	push hl
	ld e,a
	ld a,(pal_fade_amount)
	call fade_scale
	pop hl
	pop de
	ld (de),a

	
	ld a,(pal_fade_amount)
	push de
	ld e,a
	ld a,$FF
	sub e
	ld e,(ix+0)
	push hl
	call fade_scale
	pop hl
	pop de

	ld b,a
	ld a,(de)
	add a,b
	ld (de),a
	

	inc de
	inc ix

	pop bc
	djnz ++

	ld a,(pal_fade_amount)
	ld b,a
	ld a,(pal_fade_speed)
	add a,b
	or a
	jr nz,+

	ld (pal_fade_speed),a

	ld a,$FF
+:
	ld (pal_fade_amount),a


	ret

++:	jp -

;==============================================================
; SCALE VALUE: A = E*B/256
;==============================================================


fade_scale:
	or a
	ret z
	cp $FF
	jr nz,+
	ld a,e
	ret
+:	ld b,a
	ld hl,0
	ld d,0

-:	add hl,de
	djnz -
	ld a,h
	ret


;==============================================================
; START FADE USING PALETTES AT DE=>HL IN C COLOURS AT SPEED A
;==============================================================

fade_display:
	ld hl,pal_current
	ld a,(pal_fade_count)
	ld b,a
	xor a
	out (vdp_inst),a
	ld a,$C0
	out (vdp_inst),a
	ld c,vdp_data
	otir
	ret

;==============================================================
; INVERT A PALETTE OF B COLOURS LOCATED AT HL
;==============================================================

fade_invert:
-:	push bc

	ld a,(hl)
	and %00001111
	ld b,a
	ld a,15
	sub b
	ld b,a
	ld a,(hl)
	and %11110000
	srl a
	srl a
	srl a
	srl a
	ld c,a
	ld a,15
	sub c
	add a,a
	add a,a
	add a,a
	add a,a
	or b
	ld (hl),a
	inc hl

	ld a,(hl)
	and %00001111
	ld b,a
	ld a,15
	sub b
	ld (hl),a
	inc hl
	pop bc

	djnz -
	ret

;==============================================================
; GREYS OUT A PALETTE OF B COLOURS LOCATED AT HL
;==============================================================

fade_greyscale:
-:	push bc
	

	ld a,(hl)
	and %00001111
	ld c,a
	ld a,(hl)
	srl a
	srl a
	srl a
	srl a
	add a,c

	inc hl
	ld a,(hl)
	and %00001111

	add a,c
	add a,8
	
	ld b,a
	add a,a
	add a,a
	add a,b

	srl a
	srl a
	srl a
	srl a

	ld (hl),a
	
	dec hl
	ld (hl),a
	add a,a
	add a,a
	add a,a
	add a,a
	or (hl)
	ld (hl),a
	inc hl
	inc hl

	pop bc
	djnz -
	ret

;==============================================================
; COPY "TO" INTO "FROM"
;==============================================================

fade_next_fade:

	ld hl,pal_to
	ld de,pal_from
	ld bc,64
	ldir
	
	ret