; PARALLAX.ASM
; Parallax scrolling stars!



;==============================================================
; DRAW THE STARS
;==============================================================

draw_stars:
	ld b,num_stars
	ld ix,stars
-:	push bc
	ld a,(ix+2)
	and %1000000
	jr z,+

	ld b,(ix+0)
	ld c,(ix+1)
	dec c
	ld d,$48
	call draw_sprite
	
+:	call inc_ix_4
	pop bc
	djnz -
	ret

;==============================================================
; RESET THE STARS
;==============================================================


reset_stars:
	ld b,num_stars
	ld ix,stars
-:	push bc

	ld b,160
	call random
	add a,48
	ld (ix+0),a

	ld b,144
	call random
	add a,16
	ld (ix+1),a

	ld a,1
	ld (ix+2),a

	ld b,8
	call random
	add a,2
	ld (ix+3),a

	call inc_ix_4

	pop bc
	djnz -

;==============================================================
; UPDATE THE STARS
;==============================================================


update_stars:

	ld b,num_stars
	ld ix,stars
-:	push bc

	ld a,(ix+2)
	and %0111111
	dec a
	ld (ix+2),a

	jr nz,+

	ld a,(ix+3)
	ld (ix+2),a

	inc (ix+1)
	
	ld a,(ix+1)
	
	cp 144+16+8
	jr c,+

	ld a,16
	ld (ix+1),a

	ld b,8
	call random
	add a,2
	ld (ix+3),a

	ld b,160
	call random
	add a,48
	ld (ix+0),a

+:


	; IS IT VISIBLE?
	ld b,(ix+0)
	ld c,(ix+1)
	call get_name_table_loc
	srl h
	rr l
	ld de,names_ram_copy
	add hl,de
	ld a,(hl)

	or a
	jr z,is_visible_star

	ld hl,transparent_tiles
	ld bc,transparent_tiles_end-transparent_tiles
	cpir
	jr nz,is_not_visible_star

	; So, it's on a transparent tile.

	ld de,-transparent_tiles-1
	add hl,de


	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl

	; *64, as 8x8=64

	ld de,transparent_tiles_map
	add hl,de


	ld d,h
	ld e,l

	; de = pointer to mask

	ld a,(cur_scroll_index)
	add a,(ix+1)
	and %00000111

	

	ld h,0
	ld l,a

	add hl,hl
	add hl,hl
	add hl,hl

	add hl,de

	ld a,(ix+0)
	and %00000111
	ld e,a
	ld d,0
	add hl,de

	ld a,(hl)
	or a
	jr z,is_not_visible_star

is_visible_star:

	ld a,%1000000
	or (ix+2)
	ld (ix+2),a
	
is_not_visible_star:


	call inc_ix_4

	pop bc
	djnz +
	ret
+:	jp -